
local ShowMessage
do
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:SetFrameStrata("HIGH")
	frame:SetPoint("CENTER", 0, 200)
	frame:SetWidth(UIParent:GetWidth())
	frame:SetHeight(120)

	local fs = frame:CreateFontString(nil, "OVERLAY", "SystemFont_OutlineThick_WTF")
	fs:SetPoint("CENTER")
	fs:SetTextColor(1, 0.82, 0, 1)

	local anim = frame:CreateAnimationGroup()
	anim:SetScript("OnPlay", function() frame:Show() end)
	anim:SetScript("OnFinished", function() frame:Hide() end)

	local fade = anim:CreateAnimation("Alpha")
	fade:SetChange(-1)
	fade:SetDuration(0.5)
	fade:SetStartDelay(2)

	function ShowMessage(text)
		anim:Stop()
		fs:SetText(text)
		anim:Play()
	end
end

local seen = {}
local messages = {
	[41] = "OMG RARE! %s",
	[42] = "OMG EVENT!\n%s",
}

local f = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, guid)
	if event == "ZONE_CHANGED" then
		wipe(seen)
	elseif event == "VIGNETTE_ADDED" then
		if UnitOnTaxi("player") then return end

		local _, _, name, icon = C_Vignettes.GetVignetteInfoFromInstanceID(guid)

		local id = name or guid
		if seen[id] then return end
		seen[id] = true

		local text = messages[icon]
		if text then
			PlaySoundFile([[Interface\AddOns\BabiiSkulls\KittenMeow.ogg]], "master")
			ShowMessage(text:format(name or ""))
		end
	end
end)
f:RegisterEvent("VIGNETTE_ADDED")
f:RegisterEvent("ZONE_CHANGED")

